﻿using System;
using System.Windows.Forms;
using JDB;

namespace Films___Boeken_Bibliotheek
{
    public partial class Form1 : Form
    {
        DataBase db = new DataBase("db.txt", new string[] {
            "Name", "Author", "Description", "Genre", "Year", "Type" }, ',');

        int dimension = 0;
        string[][] data;

        public Form1()
        {
            InitializeComponent();
        }

        void refresh()
        {
            statusLbl.Text = "Loading database items...";
            data = db.Rows;
            listBox.Items.Clear();
            listBox.Items.AddRange(db.getListBoxStrings(dimension));
            statusLbl.Text = "Database items loaded succesfully.";
        }

        private void onLoad(object sender, EventArgs e)
        {
            searchCb.Items.AddRange(db.Columns);
            refresh();
        }


        private void refreshButton_Click(object sender, EventArgs e)
        {
            refresh();
        }

        private void addButton_Click(object sender, EventArgs e)
        {
            db.add(getWriteString());
            refresh();
            statusLbl.Text = "Succesfully added a new item";
        }

        private void listBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (data == null || listBox.SelectedIndex < 0) return;
            string[] d = db.getRow(db.getRowIndex(data[listBox.SelectedIndex]));
            if (d == null) return;
            pgb.Text = String.Format("Properties ({0})", listBox.SelectedIndex);
            
            nameTb.Text = d[0];
            authorTb.Text = d[1];
            descTb.Text = d[2];
            genreTb.Text = d[3];
            yearTb.Text = d[4];
            typeTb.Text = d[5];
            statusLbl.Text = "Viewing item " + listBox.SelectedIndex;
        }

        string[] getWriteString()
        {
            return new string[] {
                nameTb.Text, authorTb.Text, descTb.Text, genreTb.Text, yearTb.Text, typeTb.Text };
        }

        private void editButton_Click(object sender, EventArgs e)
        {
            db.edit(db.getRowIndex(data[listBox.SelectedIndex]), getWriteString());
            refresh();
            statusLbl.Text = "Succesfully edited item " + listBox.SelectedIndex.ToString() + ".";
        }

        private void clearButton_Click(object sender, EventArgs e)
        {
            nameTb.Clear();
            authorTb.Clear();
            descTb.Clear();
            genreTb.Clear();
            yearTb.Clear();
            typeTb.Clear();
            statusLbl.Text = "Cleared properties field";
        }

        private void removeButton_Click(object sender, EventArgs e)
        {
            statusLbl.Text = "Removing item...";
            db.remove(listBox.SelectedIndex);
            refresh();
            statusLbl.Text = "Succesfully removed item";
        }

        private void searchCB_SelectedIndexChanged(object sender, EventArgs e)
        {
            dimension = searchCb.SelectedIndex - 1;
        }

        private void searchButton_Click(object sender, EventArgs e)
        {
            statusLbl.Text = String.Format("Searching for \"{0}\" in category {1}...", searchTb.Text, searchCb.SelectedText);
            data = db.getRows(dimension, searchTb.Text, true, true);
            if (data == null)
            {
                listBox.Items.Clear();
                listBox.Items.Add("Nothing found");
                statusLbl.Text = "Nothing found or Error";
                return;
            }

            listBox.Items.Clear();
            listBox.Items.AddRange(db.getListBoxStrings(0, data));
            statusLbl.Text = String.Format("Got {0} results for \"{1}\" in category {2}", data.Length, searchTb.Text, searchCb.SelectedText);
        }
    }
}
